/*
Client to communicate with the back end speech engine synthserv
and the utf to phonetics convertors hindiphonserv and kannadaphonserv.
Takes 2/3 arguments, first is a file name, second is p
for phonetics files, t for utf text files, if second argument is t 
then there is a third argument, which is h or k (hindi or kannada).
 */
#include<stdio.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<sys/un.h>
#include<sys/unistd.h>
main(int argc, char * argv[])
{
	int sockfd,sockfd1,sockfd2,tmp;
	int	len,len1,len2,cnt,cnt1,cnt2=0;
	FILE *fd;
	struct sockaddr_un addr,addr1,addr2; 	
	int result;
	unsigned char ch;


	sockfd = socket(AF_UNIX,SOCK_STREAM,0);
	addr.sun_family = AF_UNIX;
	strcpy(addr.sun_path,"/tmp/hphonsocket");
	len = sizeof(addr);
        
        sockfd2 = socket(AF_UNIX,SOCK_STREAM,0);
	addr2.sun_family = AF_UNIX;
	strcpy(addr2.sun_path,"/tmp/kphonsocket");
	len2 = sizeof(addr2);         

	sockfd1 = socket(AF_UNIX,SOCK_STREAM,0);
	addr1.sun_family = AF_UNIX;
	strcpy(addr1.sun_path,"/tmp/synthsocket");
	len1 = sizeof(addr1);

        if (argv[2][0]=='p')
	  {
           result = connect(sockfd1,(struct sockaddr  *)&addr1,len1);
	   if(result == -1)
               {
		perror("ERROR");
		exit(1);	
	       };
	   fd=fopen(argv[1],"r+");
	   while((result=fread(&ch,sizeof(unsigned char),1,fd))>0){
		write(sockfd1, &ch, 1);
                fflush(stdout);
		}
	   fclose(fd);
           close(sockfd1);
           exit(0);
          }

        else

         {if (argv[2][0]=='t')
	   {if (argv[3][0]=='h')
	     {result = connect(sockfd,(struct sockaddr  *)&addr,len);
              tmp=sockfd;
             }
            else 
              {if (argv[3][0]=='k')
                {result = connect(sockfd2,(struct sockaddr  *)&addr2,len2);
                 tmp=sockfd2;
                }
              };

            if(result == -1)
                  {
	   	   perror("ERROR");
		   exit(1);	
         	  }

	    fd=fopen(argv[1],"r+");
	    while((result=fread(&ch,sizeof(unsigned char),1,fd))>0){
		write(tmp, &ch, 1);
		}
		write(tmp,&result,1);

            fclose(fd);
            close(tmp);
	    exit(0);
           }
         };
	
        







}
